<?php
ini_set('display_errors', 1);
error_reporting(E_ALL);

include(__DIR__.'/../config.php');
include(__DIR__.'/../libraries/Project.class.php');
include(__DIR__.'/../libraries/Database.class.php');

$error = array();
$message = '';
$data = array();

$mysqli = new mysqli(__DVERSIONS_MAIN_DB_HOST__, __DVERSIONS_MAIN_DB_USER__, __DVERSIONS_MAIN_DB_PASSWORD__, __DVERSIONS_MAIN_DB_NAME__, __DVERSIONS_MAIN_DB_PORT__);

if ($mysqli->connect_errno) {

	$error[] = "Failed to connect to MySQL: (".$mysqli->connect_errno.") ".$mysqli->connect_error;
}

switch ($_INPUT['mode']) {

	case 'save':

		$project = new Project($mysqli);

		$project->setName($_INPUT['name']);

		$project->setStructure($_INPUT['structure']);

		if ($project->save()) {

			$projectId = $project->getId();

			if (!empty($_INPUT['db_host']) && !empty($_INPUT['db_user']) && isset($_INPUT['db_password']) && !empty($_INPUT['db_name'])) {

				$database = new Database($mysqli);

				$database->setProperties($projectId, $_INPUT['db_host'], $_INPUT['db_user'], $_INPUT['db_password'], $_INPUT['db_name']);

				if (!$database->save()) {

					$error[] = 'Can\'t save Database';
				}
			}

		} else {

			$error[] = 'Can\'t save project';
		}

		break;

	case 'list_projects':

		if ($result = $mysqli->query('SELECT id, name FROM project LIMIT 1000')) {

			while ($row = $result->fetch_assoc()) {
				$data[] = $row;
			}

			$result->free();
		}

		break;

	default:
		header($_SERVER['SERVER_PROTOCOL'].' 400 Bad Request');
		break;
}

$return = array('data' => $data);

if (!empty($error)) {
	$return['error'] = $error;
}

if (!empty($message)) {
	$return['message'] = $message;
}

header('Content-type: '.(isset($_SERVER['HTTP_ACCEPT']) && (strpos($_SERVER['HTTP_ACCEPT'], 'application/json') !== false) ? 'application/json' : 'text/plain'));

echo json_encode($return);

