<?php
ini_set('display_errors', 0);
error_reporting(E_ALL);

include(__DIR__.'/../config.php');
include(__DIR__.'/../libraries/DatabaseSchema.class.php');

$error = array();
$message = '';
$data = array();

switch ($_INPUT['mode']) {

	case 'get':

		if (!empty($_INPUT['db_host']) && !empty($_INPUT['db_user']) && !empty($_INPUT['db_name'])) {

			$mysqli = new mysqli($_INPUT['db_host'], $_INPUT['db_user'], $_INPUT['db_password'], $_INPUT['db_name']);

			if ($mysqli->connect_errno) {

				$error[] = "Failed to connect to MySQL: (".$mysqli->connect_errno.") ".$mysqli->connect_error;
			} else {

				try {

					$databaseSchema = new DatabaseSchema($mysqli);
					$data = $databaseSchema->getSchema();
				} catch (Exception $e) {

					$error[] = $e->getMessage();
				}

			}
		}

		break;

	default:
		header($_SERVER['SERVER_PROTOCOL'].' 400 Bad Request');
		break;
}

$return = array('data' => $data);

if (!empty($error)) {
	$return['error'] = $error;
}

if (!empty($message)) {
	$return['message'] = $message;
}

header('Content-type: '.(isset($_SERVER['HTTP_ACCEPT']) && (strpos($_SERVER['HTTP_ACCEPT'], 'application/json') !== false) ? 'application/json' : 'text/plain'));

echo json_encode($return);
