<?php

class Sandbox {

	protected $db;
	protected $sandbox_db;

	function __construct(mysqli $db, mysqli $sandbox_db) {

		$this->db = $db;
		$this->sandbox_db = $sandbox_db;
	}

	public function isValidSyntax($project_id, $code) {

		$result = false;

		$structure = $this->getProjectStructure($project_id);

		if ($this->deployStructureToSandboxDB($structure)) {

			$result = $this->applyChangesToSandboxDB($code);

			$this->clear();
		}

		return $result;
	}

	protected function getProjectStructure($projectI_id) {

		$structure = '';

		if (!empty($projectI_id)) {

			$stmt = $this->db->prepare('SELECT structure FROM project WHERE id = ?');
			$stmt->bind_param('i', $projectI_id);
			$stmt->execute();
			$stmt->bind_result($structure);
			$stmt->fetch();
			$stmt->close();
		}

		return $structure;

	}

	protected function    deployStructureToSandboxDB($structure) {

		if (!empty($structure)) {

			//TO DO: check result of every query
			return $this->sandbox_db->multi_query($structure);

		}

		return false;
	}

	protected function applyChangesToSandboxDB($code) {

		if (!empty($code)) {

			//TO DO: check result of every query, save errors
			return $this->sandbox_db->multi_query($code);
		}

		return false;
	}

	protected function clear() {

		//Delete all tables in SandboxDB
	}

}