<?php

class Version {

	protected $project_id;
	protected $user_id = 1; //Admin
	protected $description;
	protected $code;
	protected $date;
	protected $user_name;
	protected $log;
	protected $db;

	function __construct(mysqli $db) {

		$this->db = $db;
	}

	public function setName($name) {

		if (!empty($name)) {

			$this->name = $name;

			return true;
		}

		return false;
	}

	public function setProperties($project_id, $description, $code) {

		$this->project_id = $project_id;
		$this->description = $description;
		$this->code = $code;
	}

	public function getProperties() {

		return array('description' => $this->description, 'code' => $this->code, 'date' => $this->date, 'user' => $this->user_name, 'log' => $this->log);
	}

	public function save() {

		if (!empty($this->project_id) && !empty($this->code)) {

			$stmt = $this->db->prepare('INSERT INTO version (project_id, user_id, description, code) VALUES (?, ?, ?, ?)');
			$stmt->bind_param('iiss', $this->project_id, $this->user_id, $this->description, $this->code);

			if ($stmt->execute()) {

				$this->id = $this->db->insert_id;

				return true;
			}

			return false;
		}

	}

	public function load($id) {

		if (!empty($id)) {

			$stmt = $this->db->prepare('SELECT v.description, v.code, v.last_updated, u.name FROM version v INNER JOIN user u ON (v.user_id=u.id)  WHERE v.id = ?');
			$stmt->bind_param('i', $id);

			if ($stmt->execute()) {

				$stmt->bind_result($this->description, $this->code, $this->date, $this->user_name);
				$stmt->fetch();
				$stmt->close();

				return true;
			}

			return false;
		}


	}
}