<!DOCTYPE html>
<!--[if lt IE 7]>
<html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>
<html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>
<html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!-->
<html class="no-js"> <!--<![endif]-->
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
	<title>Setup DVersions</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">

	<!-- Place favicon.ico and apple-touch-icon.png in the root directory -->
	<link href="css/bootstrap.min.css" rel="stylesheet" media="screen">
	<!--link href="css/bootstrap-responsive.min.css" rel="stylesheet"-->
</head>
<body>
<!--[if lt IE 7]>
<p class="chromeframe">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade
	your browser</a> or <a href="http://www.google.com/chromeframe/?redirect=true">activate Google Chrome Frame</a> to
	improve your experience.</p>
<![endif]-->

<!-- Add your site or application content here -->

<div class="container">

	<form id="addFirstProduct">
		<h2 class="form-signin-heading">Setup New Project</h2>
		<input type="text" id="inputProjectName" placeholder="Project Name">

		<div class="control-group">
			<label class="radio">

				<input type="radio" name="inputProjectType" id="inputProjectType" value="database" checked>
				Get structure from database
			</label>
			<label class="radio">
				<input type="radio" name="inputProjectType" id="inputProjectType" value="manual">
				Put database structure manually
			</label>
		</div>
		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Next</button>
			</div>
		</div>
	</form>

	<form class="form-horizontal form-signin" id="getStructureFromDatabase" style="display:none">
		<h2 class="form-signin-heading">Get Project Database Structure from MySQL</h2>
		<input type="hidden" name="mode" value="get"/>

		<div class="control-group">
			<label class="control-label" for="dbHost">Database Host</label>

			<div class="controls">
				<input type="text" name="db_host" id="dbHost" placeholder="Host"/>
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbUser">User name</label>

			<div class="controls">
				<input type="text" name="db_user" id="dbUser" placeholder="User"/>
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbPassword">Password</label>

			<div class="controls">
				<input type="text" name="db_password" id="dbPassword" placeholder="Password"/>
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbName">Database Name</label>

			<div class="controls">
				<input type="text" name="db_name" id="dbName" placeholder="Database Name"/>
			</div>
		</div>

		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Get Structure</button>
			</div>
		</div>
	</form>

	<form class="form-horizontal form-signin" id="inputStructure" style="display:none">
		<h2 class="form-signin-heading">Project Base Structure</h2>
		<textarea rows="20" name="structure" id="databaseStructure" class="input-block-level"></textarea>

		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Save project</button>
			</div>
		</div>
	</form>


</div>
<!-- /container -->

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
<!--script src="js/setup.js"></script-->

<script>
	/**
	 * define global variables - for project name and structure
	 */
	var project_name = '';
	var db_structure = '';
	var db_params = {db_host:'', db_user:'', db_password:'', db_name:''};

	/**
	 * put some actions to form
	 */
	$("#addFirstProduct").submit(function (event) {

		/* stop form from submitting normally */
		event.preventDefault();

		/* get some values from elements on the page: */
		var $form = $(this),
				structure_type = $form.find('input:radio:checked[name=inputProjectType]').val();
		project_name = $form.find('#inputProjectName').val();

		$form.hide();
		$(structure_type == 'database' ? '#getStructureFromDatabase' : '#inputStructure').show();
	});

	/**
	 * get database structure
	 */
	$("#getStructureFromDatabase").submit(function (event) {

		/* stop form from submitting normally */
		event.preventDefault();

		var $form = $(this);
		db_params = $form.serialize();

		/* get some values from elements on the page: */
		$.ajax({
			type: "GET",
			url: "api/structure.php",
			data: db_params,
			dataType: 'json'
		}).done(function (msg) {
					if (typeof msg.error === 'undefined') {
						$('#databaseStructure').val(msg.data);

						$form.hide();
						$('#inputStructure').show();
					}
					else alert('Error when getting structure: ' + msg.error);
				}).fail(function () {
					alert("Error");
				});
	});


	/**
	 * submit project info
	 */
	$("#inputStructure").submit(function (event) {

		/* stop form from submitting normally */
		event.preventDefault();

		db_structure = $(this).find('#databaseStructure').val();

		/* get some values from elements on the page: */
		$.ajax({
			type: "GET",
			url: "api/project.php",
			data: { mode: 'save',
				name: project_name,
				structure: db_structure,
				db_host: db_params.db_host,
				db_user: db_params.db_user,
				db_password: db_params.db_password,
				db_name: db_params.db_name
			},
			dataType: 'json'
		}).done(function (msg) {
					if (typeof msg.error === 'undefined') {
						window.location.href = '?done=1';
					}
					else alert('Error when saving project: ' + msg.error);
				}).fail(function () {
					alert("Generic Error");
				});
	});


</script>

</body>
</html>
