<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
	<title>DVersions : MySQL Databases Version Control</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">

	<!-- Place favicon.ico and apple-touch-icon.png in the root directory -->
	<link href="/css/bootstrap.min.css" rel="stylesheet" media="screen">
	<!--link href="css/bootstrap-responsive.min.css" rel="stylesheet"-->

	<style>
		body {
			margin-top: 60px;
		}

			/* Customize the navbar links to be fill the entire space of the .navbar */
		.navbar .navbar-inner {
			padding: 0;
		}

		.navbar .nav {
			margin: 0;
			display: table;
			width: 100%;
		}

		.navbar .nav li {
			display: table-cell;
			width: 1%;
			float: none;
		}

		.navbar .nav li a {
			text-align: center;
			border-left: 1px solid rgba(255, 255, 255, .75);
			border-right: 1px solid rgba(0, 0, 0, .1);
		}

		.navbar .nav li:first-child a {
			border-left: 0;
			border-radius: 3px 0 0 3px;
		}

		.navbar .nav li:last-child a {
			border-right: 0;
			border-radius: 0 3px 3px 0;
		}

		.grey-border {
			border: 1px solid #ddd;
			border-radius: 4px;
			-webkit-border-radius: 4px;
		}

		.soft-grey-background {
			background-color: #fafafa;
		}

		.padding10 {
			padding: 10px 30px;
		}

		.margin10 {
			margin: 10px 0;
		}

	</style>
</head>
<body>

<!-- Add your site or application content here -->

<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button type="button" class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="#">DVersions</a>

			<div class="nav-collapse collapse">
			</div>
			<!--/.nav-collapse -->
		</div>
	</div>
</div>


<div class="container">

<div class="btn-group">
	<a class="btn" href="#" id="currentProjectName">ProjectName</a>
	<a class="btn dropdown-toggle another-project-dropdown" data-toggle="dropdown" href="#"><span class="caret"></span></a>
	<ul class="dropdown-menu another-project-dropdown">
		<li><a href="#">Another Project</a></li>
	</ul>
</div>

<br/><br/>

<div class="masthead">
	<div class="navbar">
		<div class="navbar-inner">
			<div class="container">
				<ul class="nav project-modes">
					<li><a href="#" data-mode="versions" id="mainModel">Versions</a></li>
					<li><a href="#modeDatabase" data-mode="databases">Databases</a></li>
					<li><a href="#modeStructure" data-mode="structure">Structure</a></li>
				</ul>
			</div>
		</div>
	</div>
</div>


<!-- -------------------------- -->
<!-- --------VERSIONS---------- -->
<!-- -------------------------- -->
<div id="mode-versions" class="dversion-modes">

	<div class="row">
		<div class="span3">
			<ul class="nav nav-list">
				<li class="nav-header">Show versions:</li>
				<li class="active"><a href="#">All</a></li>
				<li><a href="#">Applied</a></li>
			</ul>
			<hr>
			<a href="#" class="btn btn-mini" id="addNewVersionButton">Create New Version</a>
		</div>
		<div class="span9">

			<div class="hero-unit version-mode" id="noVersionsFound" style="display:none">
				<h2>No versions found!</h2>

				<p>After initialize project base database structure you can add new versions of it (from different
					command like
					ALTER TABLE, DROP TABLE, INSERT, CREATE ROUTINE, etc).</p>

				<p><a class="btn btn-large btn-success" href="#" id="addNewVersion">Create new version</a></p>
			</div>

			<div class="version-mode" id="allVersionsList">

			</div>

			<!--div class="pagination pagination-right">
				<ul>
					<li><a href="#">Prev</a></li>
					<li class="active"><a href="#">1</a></li>
					<li><a href="#">2</a></li>
					<li><a href="#">Next</a></li>
				</ul>
			</div-->
		</div>
	</div>
</div>


<!-- setup new version -->
<div id="createNewVersion" class="dversion-modes">

	<!-- breadcrumbs if needs -->
	<ul class="breadcrumb">
		<li><a href="#">All versions</a> <span class="divider">/</span></li>
		<li class="active">Create new version</li>
	</ul>


	<form class="form-horizontal" id="newVersionForm">
		<h2 class="form-signin-heading">Create new version</h2>
		<input type="hidden" name="mode" value="getStructure"/>

		<div class="control-group">
			<label class="control-label" for="dbHost">Description</label>

			<div class="controls">
				<input type="text" name="host" id="newVersionDescription" placeholder="Add index to speedup search..." class="input-block-level" id="newVersionDescription"/>
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbUser">Commands</label>

			<div class="controls">
				<textarea rows="7" class="input-block-level" placeholder="ALTER TABLE comments ADD INDEX ..." id="newVersionCode"></textarea>
			</div>
		</div>
		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Check commands</button>
				<button type="button" class="btn">Cancel</button>
			</div>
		</div>
	</form>

	<!-- setup new version -->
	<form id="newVersionChecking">
		<h2 class="form-signin-heading">New version #3</h2>

		<dl class="dl-horizontal">
			<dt>Created by:</dt>
			<dd>Admin</dd>
			<dt>Date:</dt>
			<dd>29 May 2013</dd>
			<dt>Description:</dt>
			<dd id="checkNewVersionDescription"></dd>
			<dt>Syntax check</dt>
			<dd><span class="label label-success">Valid</span></dd>
		</dl>

		<h3>Commands</h3>
			<pre id="checkNewVersionCode"></pre>

		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Save Version</button>
				<button type="submit" class="btn btn-danger">Save &amp; ALTER ALL DATABASES</button>
				<button type="submit" class="btn">Cancel</button>
			</div>
		</div>
	</form>
</div>

<!-- -------------------------- -->
<!-- --------DATABASES--------- -->
<!-- -------------------------- -->
<div id="mode-databases" class="dversion-modes">
	<div class="version-mode" id="allDatabasesList">

		<a href="#" class="btn btn-mini" id="addNewDatabaseButton">Add New Database</a>
		<div class="grey-border soft-grey-background padding10 margin10">
			<h3>Database</h3>
			<dl class="dl-horizontal">
				<dt>Current version:</dt>
				<dd>3</dd>
				<dt>Status:</dt>
				<dd><span class="label label-success">OK</span></dd>
				<dt>Last check:</dt>
				<dd><abbr title="20 March 2013, 14:23">2 days ago</abbr></dd>
				<dt>Size:</dt>
				<dd>36.6 GB</dd>
			</dl>
			<p class="text-right"><a href="#" data-id="" class="">View details</a></p>
		</div>

		<div class="pagination pagination-right">
			<ul>
				<li><a href="#">Prev</a></li>
				<li class="active"><a href="#">1</a></li>
				<li><a href="#">2</a></li>
				<li><a href="#">Next</a></li>
			</ul>
		</div>

	</div>
</div>

<!-- add new database -->
<div id="addNewDatabase" class="dversion-modes">

	<!-- breadcrumbs if needs -->
	<ul class="breadcrumb">
		<li><a href="#">All databases</a> <span class="divider">/</span></li>
		<li class="active">Add database</li>
	</ul>


	<form class="form-horizontal" id="addDatabaseForm">
		<h2 class="form-signin-heading">Add database</h2>

		<div class="control-group">
			<label class="control-label" for="dbHost">Database Host</label>

			<div class="controls">
				<input type="text" name="db_host" id="dbHost" placeholder="Host">
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbUser">User name</label>

			<div class="controls">
				<input type="text" name="db_user" id="dbUser" placeholder="User">
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbPassword">Password</label>

			<div class="controls">
				<input type="text" name="db_password" id="dbPassword" placeholder="Password">
			</div>
		</div>
		<div class="control-group">
			<label class="control-label" for="dbName">Database Name</label>

			<div class="controls">
				<input type="text" name="db_name" id="dbName" placeholder="Database Name">
			</div>
		</div>

		<div class="control-group">
			<div class="controls">
				<button type="submit" class="btn btn-primary">Add</button>
			</div>
		</div>


	</form>

</div>

<!-- -------------------------- -->
<!-- --------STRUCTURE--------- -->
<!-- -------------------------- -->
<div id="mode-structure" class="dversion-modes">
	<ul class="nav nav-tabs">
		<li class="active"><a href="#base" data-toggle="tab">Base</a></li>
		<li><a href="#current" data-toggle="tab">Current</a></li>
	</ul>

	<div class="tab-content">
		<div class="tab-pane active" id="base">
			<dl class="dl-horizontal">
				<dt>Created date:</dt>
				<dd>03 April 2013</dd>
				<dt>Source:</dt>
				<dd>Database online dump</dd>
			</dl>

				<pre>
					mysql> CREATE TABLE t2 (c1 INT) ts_1 ENGINE NDB;
Query OK, 0 rows affected (1.00 sec)

mysql> ALTER TABLE t2 STORAGE DISK;
ERROR 1005 (HY000): Can't create table 'c.#sql-1750_3' (errno: 140)
mysql> ALTER TABLE t2 TABLESPACE ts_1 STORAGE DISK;
Query OK, 0 rows affected (3.42 sec)
Records: 0  Duplicates: 0  Warnings: 0
mysql> SHOW CREATE TABLE t2\G
*************************** 1. row ***************************
       Table: t1
Create Table: CREATE TABLE `t2` (
  `c1` int(11) DEFAULT NULL
) /*!50100 TABLESPACE ts_1 STORAGE DISK */
ENGINE=ndbcluster DEFAULT CHARSET=latin1
1 row in set (0.01 sec)
				</pre>
		</div>

		<div class="tab-pane" id="current">
			<dl class="dl-horizontal">
				<dt>Last updated date:</dt>
				<dd>03 April 2013</dd>
				<dt>Last applied version:</dt>
				<dd><a href="#version=43">#43</a></dd>
				<dt>Last saved version:</dt>
				<dd><a href="#version=46">#46</a></dd>
			</dl>

				<pre>
CREATE TABLE `t2` (
  `c1` int(11) DEFAULT NULL
) /*!50100 TABLESPACE ts_1 STORAGE DISK */
ENGINE=ndbcluster DEFAULT CHARSET=latin1
				</pre>
		</div>
	</div>
</div>

<hr>

<div class="footer">
	<p>&copy; MacPaw 2013</p>
</div>

</div>
<!-- /container -->


<script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
<script src="/js/bootstrap.min.js"></script>
<script src="/js/tmpl.min.js"></script>

<!-- this page scripts -->
<script>

	var projects = [];
	var current_project = null;
	var new_version_params = null;

	/**
	 * onload function
	 */
	$(function () {

		// load projects
		/* get some values from elements on the page: */
		$.ajax({
			type: "GET",
			url: "api/project.php",
			data: { mode: 'list_projects' },
			dataType: 'json'
		}).done(function (msg) {
					if (typeof msg.error === 'undefined') {

						projects = msg.data;

						// build projects panel
						$('#currentProjectName').text(projects[0].name);
						current_project = 0;

						if (projects.length > 0) {
							// parse another projects
						}

						loadProductVersions();

						$("#mainModel").click();
					}
					else alert('Error when loading data about projects: ' + msg.error);
				}).fail(function () {
					alert("Generic Error");
				});

		// add events
		$('.dversion-modes').hide();
		$('ul.project-modes li a').click(function (e) {
			e.preventDefault();
			$(this).parent().siblings().removeClass('active');
			$(this).parent().addClass('active');

			$('.dversion-modes').hide();
			$('#mode-' + $(this).data('mode')).show();
		});

		$('#myTab a').click(function (e) {
			e.preventDefault();
			$(this).tab('show');
		})
		$('#myTab a:last').tab('show');

		// new version create
		$('#addNewVersion, #addNewVersionButton').click(function (e) {
			e.preventDefault();
			$('.dversion-modes, #newVersionChecking').hide();
			$('#createNewVersion').show();

			// show information window
			if ($(this).hasClass('viewVersionDetails')) {
				$('#newVersionForm').hide();
				$('#newVersionChecking').show();
			}
		});

		$('#addNewDatabaseButton').click(function (e) {
			e.preventDefault();
			$('.dversion-modes, #allDatabasesList').hide();
			$('#addNewDatabase').show();
		});

		$('#newVersionForm').submit(function (e) {
			e.preventDefault();
			$('#newVersionForm').hide();
			$('#newVersionChecking').show();
		});

		$('.viewVersionDetails').click(function (e) {
			e.preventDefault();
			$('.dversion-modes').hide();
			$('#newVersionForm').hide();
			$('#createNewVersion,#newVersionChecking').show();
		});


		/**
		 * validate changes
		 */
		$("#newVersionForm").submit(function (event) {

			/* stop form from submitting normally */
			event.preventDefault();

			var $form = $(this);
			new_version_params = $form.serialize();

			/* get some values from elements on the page: */
			$.ajax({
				type: "GET",
				url: "api/structure.php",
				data: { mode: 'check_syntax', project_id: projects[current_project].id, code: $(this).find('#newVersionCode').val() },
				dataType: 'json'
			}).done(function (msg) {
//						if (typeof msg.error === 'undefined') {

							$(this).hide();
							$('#checkNewVersionCode').text($('#newVersionCode').val());
							$('#checkNewVersionDescription').text($('#newVersionDescription').val());
							$('#newVersionChecking').show();
//						}
//						else alert('Error when getting structure: ' + msg.error);
//					}).fail(function () {
//						alert("Error");
					});
		});

	});


	function loadProductVersions() {
		$.ajax({
			type: "GET",
			url: "api/project.php",
			data: { mode: 'list_versions', project_id: projects[current_project].id },
			dataType: 'json'
		}).done(function (msg) {
					if (typeof msg.error === 'undefined') {

						if (msg.data.length > 0) {
							$('#allVersionsList').html = tmpl("tmpl-demo", msg.data);
						}
						else $('#noVersionsFound').show();
					}
					else alert('Error when loading data about versions: ' + msg.error);
				}).fail(function () {
					$('#noVersionsFound').show();
				});
	}
</script>


<script type="text/x-tmpl" id="versions-listing">
	{% for (var i=0; i<o.length; i++) { %}
		<div class="grey-border soft-grey-background padding10 margin10">
			<h3>Version #{%=o[i].id%}
			<small>by Admin</small>
			</h3>
			<h4>{%=o[i].description%}</h4>
			<dl class="dl-horizontal">
				<dt>Created:</dt>
				<dd><abbr title="{%=o[i].date%}">{%=o[i].date%}</abbr></dd>
				<dt>Used commands:</dt>
				<dd><span class="label">ALTER</span></dd>
			</dl>
				<p class="text-right"><a href="#version{%=o[i].id%}" data-id="{%=o[i].id%}" class="viewVersionDetails">View details&arr;</a></p>
			</div>
	{% } %}
</script>



</body>
</html>
